/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.search.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class BenutzerSuchparameterUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String benutzerkennung;

    public java.lang.String getBenutzerkennung(){
      return benutzerkennung;
    }
    protected final java.lang.String name;

    public java.lang.String getName(){
      return name;
    }
    protected final java.lang.String viewId;

    public java.lang.String getViewId(){
      return viewId;
    }

  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK;

    public de.ivu.elect.business.wahl.entity.WahlterminUK getWahlterminUK(){
      return wahlterminUK;
    }

  public BenutzerSuchparameterUK(
java.lang.String benutzerkennung
, java.lang.String name
, java.lang.String viewId
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
,   de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK
  ) {
    super();


      this.benutzerkennung = benutzerkennung;
      this.name = name;
      this.viewId = viewId;
        this.wahlUK = wahlUK;
      this.wahlterminUK = wahlterminUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((benutzerkennung == null) ? 0 : benutzerkennung.hashCode());
                    result = result + ((name == null) ? 0 : name.hashCode());
                    result = result + ((viewId == null) ? 0 : viewId.hashCode());
        
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
                    result = result + ((wahlterminUK == null) ? 0 : wahlterminUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            BenutzerSuchparameterUK other = (BenutzerSuchparameterUK) obj;

                if (benutzerkennung == null) {
          if (other.benutzerkennung != null) {
            return false;
          }
        } else if (!benutzerkennung.equals(other.benutzerkennung)) {
          return false;
        }
                if (name == null) {
          if (other.name != null) {
            return false;
          }
        } else if (!name.equals(other.name)) {
          return false;
        }
                if (viewId == null) {
          if (other.viewId != null) {
            return false;
          }
        } else if (!viewId.equals(other.viewId)) {
          return false;
        }
        
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
                if (wahlterminUK == null) {
          if (other.wahlterminUK != null) {
            return false;
          }
        } else if (!wahlterminUK.equals(other.wahlterminUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return BenutzerSuchparameterConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlUK.getAllEntityFieldValues());
    result.addAll(wahlterminUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BenutzerSuchparameterConstants.MESSAGE_KEY_ENTITY_EINZAHL, BenutzerSuchparameterConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, benutzerkennung));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BenutzerSuchparameterConstants.MESSAGE_KEY_ENTITY_EINZAHL, BenutzerSuchparameterConstants.MESSAGE_KEY_NAME_EINZAHL, name));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BenutzerSuchparameterConstants.MESSAGE_KEY_ENTITY_EINZAHL, BenutzerSuchparameterConstants.MESSAGE_KEY_VIEW_ID_EINZAHL, viewId));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "BenutzerSuchparameterUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"benutzerkennung="+benutzerkennung
                            +", "                +"name="+name
                            +", "                +"viewId="+viewId
                                        +", "                +"wahlUK="+wahlUK
                            +", "                +"wahlterminUK="+wahlterminUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(benutzerkennung);
         list.add(name);
         list.add(viewId);
     return list;
   }

            public static <E extends BenutzerSuchparameter> java.util.Map<BenutzerSuchparameterUK, E> mappeBenutzerSuchparameterNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(BenutzerSuchparameter::getBenutzerSuchparameterUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<BenutzerSuchparameter, BenutzerSuchparameterUK> getBenutzerSuchparameterToUKFunction() {
                return BenutzerSuchparameter::getBenutzerSuchparameterUK;
                }

}
